###R Workshop with Michel Belyk, November 2014, 2016###

#text after hashtag is a comment. Use this to make notes.
#################
###Calculation###
#################
"hello world"
"R is a fancy calculator"

3+3       #addition
3-3       #subtraction
3*3       #multiplication
3/3       #divisions
3^3       #exponentiation

3==3      #equal to
3!=3      #not equal to
3>2       #greater than
3<2       #lesser than
3>2 & 3<2 #and
3>2 | 3<2 #or

#####################################
###R is an 'object based' language###
#####################################
a<-3    #'<-' means make the left thing into the right thing
a       #'a' is now an object. this line lets us look at 'a'
#in Rstudio the object "a" now appears in the topright quadrant

#now we can use 'a' in our calcuation
a+a     #addition
a-a     #subtraction
a*a     #multiplication
a/a     #divisions
a^a     #exponentiation

###########################################
###Functions are commands that do things###
###########################################
#functions always have the format >funtion_name(argument1=something, argument2=somethingelse, etc.)
#inside the () we put the value of some "arguments" these are settings or pieces of information that the function needs
#usually one of the arguments is the data that the function should operate on
#each argument has a name so you can specify it the way I did above
#...but R is pretty clever about figuring out which argument you want to set
#...especially for simple functions that don't have many arguments to tweak

###object classess
#class() takes a single argument called x
#it tells us what the class of an object is
class(x=a) #numeric
class(a)   #this is the same. R knows what I meant.

b<-"bee"  #character
class(b) 
#notice that I didn't bother telling R which argument I was giving it. CleveR!

d<-c(1,2,3) #c() concatinates its arguments into a vector
d #look at d
class(d) #d is a numeric vector

e<-c("1","2","3") #concatinate these characters into a vector
class(e) #e is a character vector

e<-factor(x=e)   #factors useful for coding categorical variables in a dataset
e #notice that the factor class gives you a handy list of its levels

f<-rbind(d,a,d*a) #bind the arguments into rows of a matrix
class(f)
f
f<-cbind(d,a,d*a) #bind the listed vectors into columns of a matrix
f #notice that we wrote over top of 'f' here. The rbind version we made above is gone forever.

colnames(f)  #get the names of matrix columns
rownames(f)  #get the names of matrix rows
colnames(f)<-c("d","a","d*a") #assign some more useful names
f

g<-cbind(e,b) #matrix of characters
class(g)
g

factor(x=c("1","2","3")) #whoa I put a function inside a function!
factor(e) #this should be exactly the same as the line above

h<-data.frame(a,b,d,e) #make the all powerful data frame! this is the format that we will generally want for our data
h #it looks a lot like a matrix, but it's more like a collection of columns

################
####Indexing####
################
#sometimes we want to look at or work on just part of an object, this is called indexing
#we use [] to do this

#for a vector
d[2] #index the second value of the vector called 'd'

#for a matrix or dataframe index like this: dataframe[RowsIWant,ColumnsIWant]
h[1,1] #index the first row, first column
h[1, ] #index the whole first row, leaving the columns slot blank gives you all of them
h[ ,1] #index the whole first column, leaving the rows slot blank gives you all of them
h[ ,c(1,2,3)] #index columns 1, 2, and 3
h[ , 1:3]     #equivalent to the above
h[ ,d]        #equivalent to the above. remember from above d<-c(1,2,3)
h[ ,c(TRUE,TRUE,FALSE,FALSE)] #index first two columns
h[ ,"d"] #index the column called d

#this is a special way to index columns of a dataframe.
#it can be convenient because it lets you refer to columns by name
h$"d"    #equivalent to the above
h$d      #equivalent to the above

############################
###Some usefule functions###
############################
#functions are commands that do useful things for you. 
#You'll know a function when you see one because they always take the same form
#FUNCTION.NAME(arguments)...where arguments are pieces of information that you provide
#we already used some simple functions above, here are more useful functions.

###manage your working directory
getwd() #list the current working directory, this is where R reads/saves data
setwd("/Users/belykm/Dropbox/webcontent/manuals/R_workshop_scripts") #set this to your own working directory. On a PC you may need to use \ instead of /
getwd() #see the change?

###manage the objects in memory
ls()    #list the names of every object in memory
rm("h") #remove the object called 'h' from memory
ls() #in Rstudio you can also see these in the top right panel

#list is an argument to rm().
#it lets you list the objects you want removed
#since ls() lists all objects..
rm(list=ls()) #removes all objects! 
ls() #see I told you so

###R is not a spreadsheet program, but you can still peak at the data
data(cars)  #load a built-in dataset called 'cars' for us to play with
ls()
class(cars) #the new object "cars" is a data.frame
names(cars) #look at the column names
head(cars)  #look at the top few rows
tail(cars)  #look at the bottom few rows
dim(cars)   #how many rows and columns are in the dataframe?
cars        #look at the whole data.frame. Practical only for very small datasets.

###add a new column to the dataframe
car.id<-paste("car",1:50, sep="") #combine text elements into a vector
car.id
?paste #open the help page for this function. see if you can figure out what I did.

cars$"ID"<-car.id #store our new object to a new column called "ID" in cars
head(cars) #see it?
rm(car.id) #this object is redundant now that we saved it in cars

###
###Take a few minutes to explore dataframe and other
###

###basic summary statistics
mean(cars$"speed")   #the mean of column "speed" in dataframe "cars"
mean(cars[,1])       #same as above
median(cars$speed)   #the median of column speed in dataframe "cars"
sd(cars[,1])         #the standard deviation of the first column (which is also "speed")
sum(cars[,"speed"])  #notice that the three previous lines all index the same column
min(cars$"speed")
max(cars$"speed")
range(cars$"speed")
length(cars$"speed") #number of observations. we should already know this from dim(cars)
sum(cars$"speed")/length(cars$"speed") #you can combine functions in the same line. mean=sum/n
summary(cars) 


?subset #take a look at the help page for this one
cars$"speed">15.4 #which cars went faster than the mean?
subset(x=cars,subset=cars$"speed">15.4 )   #find all of those rows
cars$"speed">15.4 & cars$"dist"< mean(cars$"dist") #which cars went fast AND did not go very far
x<-subset(x=cars,subset=cars$"speed">15.4 & cars$"dist"< mean(cars$"dist")) #find those rows, save them as a new dataframe x
x
summary(x)

#####################################
###Load and Save your own datasets###
#####################################
#people complain about not knowing how to do this all the time. So here it is, and it's easy!
?write.table
write.table(cars,file="data.csv",sep=",") #save dataframe cars as comma seoarated .csv
write.table(cars,file="data.txt",sep=" ") #save dataframe cars as white scpace separated .txt
ls()
rm(list=ls())
ls()

?read.table
cars<-read.table(file="data.csv",sep=",") #load dataframe from .csv
cars<-read.table(file="data.txt",sep=" ") #load dataframe from .txt
ls()
head(cars)

save.image("R workshop.Rdata") #save all of the objects in memory
load("R workshop.Rdata")       #load objects from a previous session into memory


###Here I'll synthesize some data for us to play with. Don't worry too much about this.
set.seed(123) #get the same "random" numbers each time
dat1<-data.frame(factor(paste("S",1:10, sep="")),#first column: subject IDs
                 sort(rnorm(n=10,mean=10, sd=5)),      #second columns: 10 normally distributed numbers
                 sort(rnorm(n=10,mean=15, sd=6)),
                 sort(rnorm(n=10,mean=25, sd=7)))     
names(dat1)<-    c("subjects","treatmentA","treatmentB","treatmentC") #name the colunms                   

head(dat1)   #look at the top few rows                    
tail(dat1)   #look at the bottom few rows
dat1         #look at the whole dataframe. not practical for large datasets

######################################
###extending the functionality of R###
######################################
#there are many freely available packages that give you access to more functions
#I will download and demonstrate a really useful package here
#R usually perfers LONG format over WIDE format, which is opposite to SPSS
#transorming between long and wide format is a notorious tricky problem
#anyone who has done this by hand in excel knows that it's the wors f***ing thing in the world
#it's repetitive and boring, but computers are good at that kind of thing
#...so here is a solution

install.packages("reshape") #download a package titled "reshape". Run once per machine
library("reshape")          #loads the package into memory, run this every session
#for complete package documentation: http://cran.r-project.org/web/packages/reshape/reshape.pdf
#this page provides help for all of the functions in the package. all packages will have a handy help page like this

###melt() is a function that we gained by loading the package
dim(dat1) #10 rows, 4 columns
dat1.melt<-melt(dat1, id="subjects")
dim(dat1.melt) #30 rows, 3 columns
dat1.melt #take a look and see if you can make sense of this

#other functions in this package cover LONG to WIDE transformation
#...but they are much more complicated and don't come up often



#LONG format lets us use powerful functions like tapply() which makes nice summary tables
?tapply
tapply(X=dat1.melt$"value", INDEX=dat1.melt$"variable", FUN=mean)
tapply(dat1.melt$"value", dat1.melt$"variable", sd) #swap out for a different function
tapply(dat1.melt$"value", dat1.melt$"variable", length)
tapply(dat1.melt$"value", dat1.melt$"variable", min)
tapply(dat1.melt$"value", dat1.melt$"variable", max)
#looking for useful package? Check out http://cran.r-project.org/web/views/
#Task Views review packages that are useful for specific topics. See what's out there.

save.image("R workshop.Rdata") #save all of the objects in memory
 rm(list=ls())
